Require Import Sequences.

Inductive term: Type :=
  | Var (x: nat)
  | Lam (a: term)
  | App (a b: term)
  | Clos (a: term) (e: env)

with env: Type :=
  | Nil
  | Cons (a: term) (e: env).

Module Krivine.

Inductive red: term -> term -> Prop :=
  | red_var_O: forall a e,
      red (Clos (Var O) (Cons a e))
          a
  | red_var_S: forall n a e,
      red (Clos (Var (S n)) (Cons a e))
          (Clos (Var n) e)
  | red_beta: forall a e b,
      red (App (Clos (Lam a) e) b)
          (Clos a (Cons b e))
  | red_clos_app: forall a b e,
      red (Clos (App a b) e)
          (App (Clos a e) (Clos b e)).


